//+------------------------------------------------------------------+
//|                                                   Adaptation.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Adaptation"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input ENUM_APPLIED_PRICE iPrice=PRICE_CLOSE;
input ushort iPeriod=14,
             Parametr=0;
ushort N=2,p;
double buffer[],coeff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   N=MathMax(N,iPeriod);

   ArrayResize(coeff,N);
   ArrayInitialize(coeff,1.0/N);

   p=Parametr==0?N:Parametr;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);

   int bars=prev_calculated>0? rates_total-prev_calculated:rates_total-N-2;

   for(int i=bars; i>=0; i--)
     {
      if(rates_total>prev_calculated)
        {
         double indicator=0,M=p;
         for(int j=1; j<=N; j++)
           {
            int p1=i+j;
            indicator=indicator+coeff[j-1]*price(open[p1],high[p1],low[p1],close[p1]);
            M=M+MathPow(price(open[p1],high[p1],low[p1],close[p1]),2);
           }
         double error=price(open[i+1],high[i+1],low[i+1],close[i+1])-indicator;

         for(int j=1; j<=N; j++)
           {
            int p1=i+j;
            coeff[j-1]=coeff[j-1]+price(open[p1],high[p1],low[p1],close[p1])*error/M;
           }
        }

      double indicator=0;
      for(int j=0; j<N; j++)
        {
         int p1=i+j;
         indicator=indicator+coeff[j]*price(open[p1],high[p1],low[p1],close[p1]);
        }

      buffer[i]=indicator;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
  }
//+------------------------------------------------------------------+
