//+------------------------------------------------------------------+
//|                                                 Adaptive CCI.mq4 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_level1 0
#property indicator_level2 0
#property indicator_levelcolor clrGray
#property indicator_levelstyle STYLE_DOT
#property indicator_levelwidth 1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Adaptive CCI"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

input ENUM_APPLIED_PRICE iPrice=PRICE_CLOSE;
input ushort iPeriod=14,
             Parametr=0,
             Level=70;
ushort N=2,p,level=1;
double buffer[],coeff[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   SetIndexEmptyValue(0,EMPTY_VALUE);

   N=MathMax(N,iPeriod);

   ArrayResize(coeff,N);
   ArrayInitialize(coeff,1.0/N);

   p=Parametr==0?N:Parametr;

   level=(uchar)MathMin(MathMax(Level,level),99);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(close,true);
   static int array_dn[],size_dn,array_up[],size_up;
   int bars=prev_calculated>0? rates_total-prev_calculated:rates_total-N-2;

   for(int i=bars; i>=0; i--)
     {
      if(rates_total>prev_calculated)
        {
         double indicator=0,M=p;
         for(int j=1; j<=N; j++)
           {
            int pos=i+j;
            double pr=price(open[pos],high[pos],low[pos],close[pos]);
            indicator=indicator+coeff[j-1]*pr;
            M=M+MathPow(pr,2);
           }
         double error=price(open[i+1],high[i+1],low[i+1],close[i+1])-indicator;

         for(int j=1; j<=N; j++)
           {
            int pos=i+j;
            coeff[j-1]=coeff[j-1]+price(open[pos],high[pos],low[pos],close[pos])*error/M;
           }
        }

      double indicator=price(open[i],high[i],low[i],close[i]);
      for(int j=0; j<N; j++)
        {
         int pos=i+j;
         indicator=indicator-coeff[j]*price(open[pos],high[pos],low[pos],close[pos]);
        }

      buffer[i]=indicator;

      if(i>0)
        {
         if(indicator>0)
           {
            ArrayResize(array_up,size_up+1);
            array_up[size_up]=(int)MathRound(indicator/_Point);
            size_up++;
           }
         if(indicator<0)
           {
            ArrayResize(array_dn,size_dn+1);
            array_dn[size_dn]=(int)MathRound(-indicator/_Point);
            size_dn++;
           }

         if(i==1)
           {
            ArraySort(array_up);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,0,array_up[size_up*level/100]*_Point);
            ArraySort(array_dn);
            IndicatorSetDouble(INDICATOR_LEVELVALUE,1,-array_dn[size_dn*level/100]*_Point);
           }
        }
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double price(double o,double h,double l,double c)
  {
   if(iPrice==PRICE_CLOSE)
      return(c);
   if(iPrice==PRICE_OPEN)
      return(o);
   if(iPrice==PRICE_HIGH)
      return(h);
   if(iPrice==PRICE_LOW)
      return(l);
   if(iPrice==PRICE_MEDIAN)
      return((h+l)/2);
   if(iPrice==PRICE_TYPICAL)
      return(h+l+c)/3;
   return(h+l+2*c)/4;
  }
//+------------------------------------------------------------------+
