//+------------------------------------------------------------------+
//|                                                 Adaptive EMA.mq5 |
//|                                                        AIS Forex |
//|                        https://www.mql5.com/en/users/aleksej1966 |
//+------------------------------------------------------------------+
#property copyright "AIS Forex"
#property link      "https://www.mql5.com/en/users/aleksej1966"
#property version   "1.00"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_plots   1

#property indicator_type1  DRAW_LINE
#property indicator_label1 "Adaptive EMA"
#property indicator_color1 clrBlue
#property indicator_width1 1
#property indicator_style1 STYLE_SOLID

#property indicator_applied_price PRICE_CLOSE

input ushort Parameter=1;
ushort p=1;
double buffer[],c1=0.5,c2=0.5;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,buffer,INDICATOR_DATA);
   ArraySetAsSeries(buffer,true);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);

   p=MathMax(p,Parameter);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---
   ArraySetAsSeries(price,true);

   int bars=rates_total-prev_calculated;

   if(prev_calculated==0)
     {
      bars=rates_total-3;
      buffer[rates_total-1]=price[rates_total-1];
     }

   for(int i=bars; i>=0; i--)
     {
      if(rates_total>prev_calculated)
        {

         double m=p+MathPow(price[i+1],2)+MathPow(buffer[i+2],2),
                error=(1-c1)*price[i+1]-c2*buffer[i+2];

         c1=c1+price[i+1]*error/m;
         c2=c2+buffer[i+2]*error/m;
        }

      buffer[i]=c1*price[i]+c2*buffer[i+1];
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
